//NESGG.CPP
//(Hopefully) converts to and from NES GG codes and hex codes
//By Cheatmaster (dlucas@inlink.com)
//6-22-98

#include <iostream.h>
#include <ctype.h>
#include <stdio.h>

void clrscreen(void)	//Clears the screen--IF it is a 25 line display
{
	int ctr;
	for (ctr = 1; ctr <= 26; ctr++)
		{ cout << "\n"; }
}

int Bad6(char Code6[])	//Weed out invalid codes, fix fakies
{
	int ctr;

	for (ctr = 0; ctr <=5; ctr++)
	{
		switch (toupper(Code6[ctr]))	//I'm not testing for little letters
		{
			case 'A':
				break;
			case 'P':
				break;
			case 'Z':
				break;
			case 'L':
				break;
			case 'G':
				break;
			case 'I':
				break;
			case 'T':
				break;
			case 'Y':
				break;
			case 'E':
				break;
			case 'O':
				break;
			case 'X':
				break;
			case 'U':
				break;
			case 'K':
				break;
			case 'S':
				break;
			case 'V':
				break;
			case 'N':
				break;
			default:
				return 1;		//If it ain't any of the above...
		}
	}
	switch (toupper(Code6[2]))	//Check the 3rd char. now
	{
		case 'E':
			Code6[2] = 'A';
			break;
		case 'O':
			Code6[2] = 'P';
			break;
		case 'X':
			Code6[2] = 'Z';
			break;
		case 'U':
			Code6[2] = 'L';
			break;
		case 'K':
			Code6[2] = 'G';
			break;
		case 'S':
			Code6[2] = 'I';
			break;
		case 'V':
			Code6[2] = 'T';
			break;
		case 'N':
			Code6[2] = 'Y';
			break;
	}
	return 0;		//If it's survived this far, it's OK
}

int Bad8(char Code8[])
{
	int ctr;

	for (ctr = 0; ctr <=7; ctr++)
	{
		switch (toupper(Code8[ctr]))
		{
			case 'A':
				break;
			case 'P':
				break;
			case 'Z':
				break;
			case 'L':
				break;
			case 'G':
				break;
			case 'I':
				break;
			case 'T':
				break;
			case 'Y':
				break;
			case 'E':
				break;
			case 'O':
				break;
			case 'X':
				break;
			case 'U':
				break;
			case 'K':
				break;
			case 'S':
				break;
			case 'V':
				break;
			case 'N':
				break;
			default:
				return 1;
		}
	}
	switch (toupper(Code8[2]))	//Char. 3 MUST be in the E-N range
	{
		case 'E':
			break;
		case 'O':
			break;
		case 'X':
			break;
		case 'U':
			break;
		case 'K':
			break;
		case 'S':
			break;
		case 'V':
			break;
		case 'N':
			break;
		default:
			return 1;
	}
	return 0;
}

int Bad6H(char Code6[])
{
	int ctr;

	for (ctr = 0; ctr <=6; ctr++)
	{
		if ((ctr == 4) && (Code6[4] == ':'))	//Ignore punctuation
			{ continue; }
		if ((ctr == 6) && (Code6[6] == '\0'))	//May end 1 early
			{ continue; }
		switch (toupper(Code6[ctr]))
		{
			case '0':
				break;
			case '1':
				break;
			case '2':
				break;
			case '3':
				break;
			case '4':
				break;
			case '5':
				break;
			case '6':
				break;
			case '7':
				break;
			case '8':
				break;
			case '9':
				break;
			case 'A':
				break;
			case 'B':
				break;
			case 'C':
				break;
			case 'D':
				break;
			case 'E':
				break;
			case 'F':
				break;
			default:
				return 1;
		}
	}
	if (int(Code6[0]) > 55)	//Can only be 0-7 (7=55 ASCII)
		{ return 1; }
	return 0;
}

int Bad8H(char Code8[])
{
	int ctr;

	for (ctr = 0; ctr <=9; ctr++)
	{
		if ((ctr == 4) && (Code8[4] == '?'))
			{ continue; }
		if ((ctr == 7) && (Code8[7] == ':'))
			{ continue; }
		if ((ctr >= 8) && (Code8[ctr] == '\0'))
			{ continue; }
		switch (toupper(Code8[ctr]))
		{
			case '0':
				break;
			case '1':
				break;
			case '2':
				break;
			case '3':
				break;
			case '4':
				break;
			case '5':
				break;
			case '6':
				break;
			case '7':
				break;
			case '8':
				break;
			case '9':
				break;
			case 'A':
				break;
			case 'B':
				break;
			case 'C':
				break;
			case 'D':
				break;
			case 'E':
				break;
			case 'F':
				break;
			default:
				return 1;
		}
	}
	if (int(Code8[0]) > 55)	//Can only be 0-7 (7=55 ASCII)
		{ return 1; }
	return 0;
}

void G6H(char Code6[])	//The meat of this section!
{
	int in[24];
	int out[24];
	int dec[6];
	char HCode[8];
	int ctr;
	int ttl;

	for (ctr = 0; ctr <= 5; ctr++)
	{
		switch (toupper(Code6[ctr]))
		{
			case 'A':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'P':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'Z':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'L':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'G':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'I':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'T':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'Y':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'E':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'O':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'X':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'U':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'K':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'S':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'V':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'N':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
		}
	}
	out[0] = 0;		//ALWAYS 0, no matter what!!!
	out[1] = in[13];
	out[2] = in[14];
	out[3] = in[15];
	out[4] = in[16];
	out[5] = in[21];
	out[6] = in[22];
	out[7] = in[23];
	out[8] = in[4];
	out[9] = in[9];
	out[10] = in[10];
	out[11] = in[11];
	out[12] = in[12];
	out[13] = in[17];
	out[14] = in[18];
	out[15] = in[19];
	out[16] = in[0];
	out[17] = in[5];
	out[18] = in[6];
	out[19] = in[7];
	out[20] = in[20];
	out[21] = in[1];
	out[22] = in[2];
	out[23] = in[3];
	for (ctr = 0; ctr <=5; ctr++)
	{
		ttl = 0;
		if (out[(4 * ctr)])
			{ ttl = ttl + 8; }
		if (out[((4 * ctr) + 1)])
			{ ttl = ttl + 4; }
		if (out[((4 * ctr) + 2)])
			{ ttl = ttl + 2; }
		if (out[((4 * ctr) + 3)])
			{ ttl = ttl + 1; }
		dec[ctr] = ttl;
	}
	ttl = 0;
	for (ctr = 0; ctr <=7; ctr++)
	{
		if (ctr == 4)
		{
			HCode[4] = ':';
			continue;
		}
		if (ctr == 7)
		{
			HCode[7] = '\0';	//Have to put this on the end?
			continue;
		}
		switch (dec[ttl])
		{
			case 0:
				HCode[ctr] = '0';
				break;
			case 1:
				HCode[ctr] = '1';
				break;
			case 2:
				HCode[ctr] = '2';
				break;
			case 3:
				HCode[ctr] = '3';
				break;
			case 4:
				HCode[ctr] = '4';
				break;
			case 5:
				HCode[ctr] = '5';
				break;
			case 6:
				HCode[ctr] = '6';
				break;
			case 7:
				HCode[ctr] = '7';
				break;
			case 8:
				HCode[ctr] = '8';
				break;
			case 9:
				HCode[ctr] = '9';
				break;
			case 10:
				HCode[ctr] = 'A';
				break;
			case 11:
				HCode[ctr] = 'B';
				break;
			case 12:
				HCode[ctr] = 'C';
				break;
			case 13:
				HCode[ctr] = 'D';
				break;
			case 14:
				HCode[ctr] = 'E';
				break;
			case 15:
				HCode[ctr] = 'F';
				break;
		}
		ttl++;
	}
	cout << HCode << "\n";
}

void G8H(char Code8[])
{
	int in[32];
	int out[32];
	int dec[8];
	char HCode[11];
	int ctr;
	int ttl;

	for (ctr = 0; ctr <= 7; ctr++)
	{
		switch (toupper(Code8[ctr]))
		{
			case 'A':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'P':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'Z':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'L':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'G':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'I':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'T':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'Y':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'E':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'O':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'X':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'U':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'K':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'S':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'V':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'N':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
		}
	}
	out[0] = 0;
	out[1] = in[13];
	out[2] = in[14];
	out[3] = in[15];
	out[4] = in[16];
	out[5] = in[21];
	out[6] = in[22];
	out[7] = in[23];
	out[8] = in[4];
	out[9] = in[9];
	out[10] = in[10];
	out[11] = in[11];
	out[12] = in[12];
	out[13] = in[17];
	out[14] = in[18];
	out[15] = in[19];
	out[16] = in[24];
	out[17] = in[29];
	out[18] = in[30];
	out[19] = in[31];
	out[20] = in[20];
	out[21] = in[25];
	out[22] = in[26];
	out[23] = in[27];
	out[24] = in[0];
	out[25] = in[5];
	out[26] = in[6];
	out[27] = in[7];
	out[28] = in[28];
	out[29] = in[1];
	out[30] = in[2];
	out[31] = in[3];
	for (ctr = 0; ctr <=7; ctr++)
	{
		ttl = 0;
		if (out[(4 * ctr)])
			{ ttl = ttl + 8; }
		if (out[((4 * ctr) + 1)])
			{ ttl = ttl + 4; }
		if (out[((4 * ctr) + 2)])
			{ ttl = ttl + 2; }
		if (out[((4 * ctr) + 3)])
			{ ttl = ttl + 1; }
		dec[ctr] = ttl;
	}
	ttl = 0;
	for (ctr = 0; ctr <=10; ctr++)
	{
		if (ctr == 4)
		{
			HCode[4] = '?';
			continue;
		}
		if (ctr == 7)
		{
			HCode[7] = ':';
			continue;
		}
		if (ctr == 10)
		{
			HCode[10] = '\0';
			continue;
		}
		switch (dec[ttl])
		{
			case 0:
				HCode[ctr] = '0';
				break;
			case 1:
				HCode[ctr] = '1';
				break;
			case 2:
				HCode[ctr] = '2';
				break;
			case 3:
				HCode[ctr] = '3';
				break;
			case 4:
				HCode[ctr] = '4';
				break;
			case 5:
				HCode[ctr] = '5';
				break;
			case 6:
				HCode[ctr] = '6';
				break;
			case 7:
				HCode[ctr] = '7';
				break;
			case 8:
				HCode[ctr] = '8';
				break;
			case 9:
				HCode[ctr] = '9';
				break;
			case 10:
				HCode[ctr] = 'A';
				break;
			case 11:
				HCode[ctr] = 'B';
				break;
			case 12:
				HCode[ctr] = 'C';
				break;
			case 13:
				HCode[ctr] = 'D';
				break;
			case 14:
				HCode[ctr] = 'E';
				break;
			case 15:
				HCode[ctr] = 'F';
				break;
		}
		ttl++;
	}
	cout << HCode << "\n";
}

void H6G(char Code6[])
{
	int in[24];
	int out[24];
	int dec[6];
	char GCode[8];
	int ctr;
	int ttl;

	if (Code6[4] == ':')	//Squeeze out all punctuation
	{
		Code6[4] = Code6[5];
		Code6[5] = Code6[6];
		Code6[6] = '\0';
	}
	for (ctr = 0; ctr <= 5; ctr++)
	{
		switch (toupper(Code6[ctr]))
		{
			case '0':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '1':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '2':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '3':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '4':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '5':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '6':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '7':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '8':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '9':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'A':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'B':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'C':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'D':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'E':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'F':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
		}
	}
	out[8] = 0;		//Bit 9=0 in 6-char. codes, 1 in 8-char.
	out[13] = in[1];
	out[14] = in[2];
	out[15] = in[3];
	out[16] = in[4];
	out[21] = in[5];
	out[22] = in[6];
	out[23] = in[7];
	out[4] = in[8];
	out[9] = in[9];
	out[10] = in[10];
	out[11] = in[11];
	out[12] = in[12];
	out[17] = in[13];
	out[18] = in[14];
	out[19] = in[15];
	out[0] = in[16];
	out[5] = in[17];
	out[6] = in[18];
	out[7] = in[19];
	out[20] = in[20];
	out[1] = in[21];
	out[2] = in[22];
	out[3] = in[23];
	for (ctr = 0; ctr <=5; ctr++)
	{
		ttl = 0;
		if (out[(4 * ctr)])
			{ ttl = ttl + 8; }
		if (out[((4 * ctr) + 1)])
			{ ttl = ttl + 4; }
		if (out[((4 * ctr) + 2)])
			{ ttl = ttl + 2; }
		if (out[((4 * ctr) + 3)])
			{ ttl = ttl + 1; }
		dec[ctr] = ttl;
	}
	ttl = 0;
	for (ctr = 0; ctr <=6; ctr++)
	{
		if (ctr == 6)
		{
			GCode[6] = '\0';
			continue;
		}
		switch (dec[ttl])
		{
			case 0:
				GCode[ctr] = 'A';
				break;
			case 1:
				GCode[ctr] = 'P';
				break;
			case 2:
				GCode[ctr] = 'Z';
				break;
			case 3:
				GCode[ctr] = 'L';
				break;
			case 4:
				GCode[ctr] = 'G';
				break;
			case 5:
				GCode[ctr] = 'I';
				break;
			case 6:
				GCode[ctr] = 'T';
				break;
			case 7:
				GCode[ctr] = 'Y';
				break;
			case 8:
				GCode[ctr] = 'E';
				break;
			case 9:
				GCode[ctr] = 'O';
				break;
			case 10:
				GCode[ctr] = 'X';
				break;
			case 11:
				GCode[ctr] = 'U';
				break;
			case 12:
				GCode[ctr] = 'K';
				break;
			case 13:
				GCode[ctr] = 'S';
				break;
			case 14:
				GCode[ctr] = 'V';
				break;
			case 15:
				GCode[ctr] = 'N';
				break;
		}
		ttl++;
	}
	cout << GCode << "\n";
}

void H8G(char Code8[])
{
	int in[32];
	int out[32];
	int dec[8];
	char GCode[11];
	int ctr;
	int ttl;

	if (Code8[4] == '?')
	{
		Code8[4] = Code8[5];
		Code8[5] = Code8[6];
		Code8[6] = Code8[7];
		Code8[7] = Code8[8];
		Code8[8] = Code8[9];
		Code8[9] = '\0';
	}
	if (Code8[6] == ':')
	{
		Code8[6] = Code8[7];
		Code8[7] = Code8[8];
		Code8[8] = '\0';
	}
	for (ctr = 0; ctr <= 7; ctr++)
	{
		switch (toupper(Code8[ctr]))
		{
			case '0':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '1':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '2':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '3':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '4':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '5':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '6':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '7':
				in[(4 * ctr)] = 0;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case '8':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case '9':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'A':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'B':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 0;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'C':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'D':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 0;
				in[((4 * ctr) + 3)] = 1;
				break;
			case 'E':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 0;
				break;
			case 'F':
				in[(4 * ctr)] = 1;
				in[((4 * ctr) + 1)] = 1;
				in[((4 * ctr) + 2)] = 1;
				in[((4 * ctr) + 3)] = 1;
				break;
		}
	}
	out[8] = 1;
	out[13] = in[1];
	out[14] = in[2];
	out[15] = in[3];
	out[16] = in[4];
	out[21] = in[5];
	out[22] = in[6];
	out[23] = in[7];
	out[4] = in[8];
	out[9] = in[9];
	out[10] = in[10];
	out[11] = in[11];
	out[12] = in[12];
	out[17] = in[13];
	out[18] = in[14];
	out[19] = in[15];
	out[24] = in[16];
	out[29] = in[17];
	out[30] = in[18];
	out[31] = in[19];
	out[20] = in[20];
	out[25] = in[21];
	out[26] = in[22];
	out[27] = in[23];
	out[0] = in[24];
	out[5] = in[25];
	out[6] = in[26];
	out[7] = in[27];
	out[28] = in[28];
	out[1] = in[29];
	out[2] = in[30];
	out[3] = in[31];
	for (ctr = 0; ctr <=7; ctr++)
	{
		ttl = 0;
		if (out[(4 * ctr)])
			{ ttl = ttl + 8; }
		if (out[((4 * ctr) + 1)])
			{ ttl = ttl + 4; }
		if (out[((4 * ctr) + 2)])
			{ ttl = ttl + 2; }
		if (out[((4 * ctr) + 3)])
			{ ttl = ttl + 1; }
		dec[ctr] = ttl;
	}
	ttl = 0;
	for (ctr = 0; ctr <=8; ctr++)
	{
		if (ctr == 8)
		{
			GCode[8] = '\0';
			continue;
		}
		switch (dec[ttl])
		{
			case 0:
				GCode[ctr] = 'A';
				break;
			case 1:
				GCode[ctr] = 'P';
				break;
			case 2:
				GCode[ctr] = 'Z';
				break;
			case 3:
				GCode[ctr] = 'L';
				break;
			case 4:
				GCode[ctr] = 'G';
				break;
			case 5:
				GCode[ctr] = 'I';
				break;
			case 6:
				GCode[ctr] = 'T';
				break;
			case 7:
				GCode[ctr] = 'Y';
				break;
			case 8:
				GCode[ctr] = 'E';
				break;
			case 9:
				GCode[ctr] = 'O';
				break;
			case 10:
				GCode[ctr] = 'X';
				break;
			case 11:
				GCode[ctr] = 'U';
				break;
			case 12:
				GCode[ctr] = 'K';
				break;
			case 13:
				GCode[ctr] = 'S';
				break;
			case 14:
				GCode[ctr] = 'V';
				break;
			case 15:
				GCode[ctr] = 'N';
				break;
		}
		ttl++;
	}
	cout << GCode << "\n";
}

void GG6(void)		//6-char. GG to unconditional hex
{
	char G6Code[15];	//Have to leave room for bobos who enter 7 letters
	char x = 'Y';

	clrscreen();
	while (toupper(x) == 'Y')
	{
		cout << "\nEnter ONE code and press Enter: ";
		gets(G6Code);
		if (Bad6(G6Code))
			{ cout << "\nInvalid code. "; }
		else
			{ G6H(G6Code); }
		cout << "Enter another? (Y/N) ";
		cin >> x;
	}
}

void GG8(void)		//8-char. GG to conditional hex
{
	char G8Code[15];
	char x = 'Y';

	clrscreen();
	while (toupper(x) == 'Y')
	{
		cout << "\nEnter ONE code and press Enter: ";
		gets(G8Code);
		if (Bad8(G8Code))
			{ cout << "\nInvalid code. "; }
		else
			{ G8H(G8Code); }
		cout << "Enter another? (Y/N) ";
		cin >> x;
	}
}

void Hex6(void)		//Unconditional hex to 6-char GG
{
	char H6Code[15];
	char x = 'Y';

	clrscreen();
	while (toupper(x) == 'Y')
	{
		cout << "\nEnter ONE code and press Enter: ";
		gets(H6Code);
		if (Bad6H(H6Code))
			{ cout << "\nInvalid code. "; }
		else
			{ H6G(H6Code); }
		cout << "Enter another? (Y/N) ";
		cin >> x;
	}
}

void Hex8(void)		//Conditional hex to 8-char GG
{
	char H8Code[15];
	char x = 'Y';

	clrscreen();
	while (toupper(x) == 'Y')
	{
		cout << "\nEnter ONE code and press Enter: ";
		gets(H8Code);
		if (Bad8H(H8Code))
			{ cout << "\nInvalid code. "; }
		else
			{ H8G(H8Code); }
		cout << "Enter another? (Y/N) ";
		cin >> x;
	}
}

void main(void)	//Here's where the party starts
{
	int mc = 0;

	while (mc != 5)
	{
		clrscreen();
		cout << "1. 6-char GG to hex\n";
		cout << "2. 8-char GG to hex\n";
		cout << "3. Unconditional hex to GG\n";
		cout << "4. Conditional hex to GG\n";
		cout << "5. Quit\n\n";
		cout << "Selection --> ";
		cin >> mc;
		if (mc == 1)
			{ GG6(); }
		if (mc == 2)
			{ GG8(); }
		if (mc == 3)
			{ Hex6(); }
		if (mc == 4)
			{ Hex8(); }
		if (mc != 5)
			{ mc = 0; }
	}
}
